"""Copyright (c) 2008 by Eckhart Arnold (www.eckhartarnold.de)
                   
License: GNU Public License V3
(http://www.gnu.de/documents/gpl-3.0.en.html)

This program is free software: you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the 
Free Software Foundation, either version 3 of the License, or (at your 
option) any later version.

This program is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
Public License for more details.

You should have received a copy of the GNU General Public License along 
with this program. If not, see <http://www.gnu.org/licenses/>.
"""

POPULATION_SIZE = 100
ENVIRONMENT_SIZE = 100

ILLEGAL     = -2
INNOVATE    = -1
OBSERVE     =  0
EXPLOIT_MIN =  1
EXPLOIT_MAX = ENVIRONMENT_SIZE + EXPLOIT_MIN - 1

MATCH_LENGTH = 10000

PW_INIT_PHASE  = 100
PW_REPETITIONS = 20
MELEE_REPETITIONS = 100

MIN_PAYOFF = 0
MAX_PAYOFF = 100

PC_MIN = 0.001
PC_MAX = 0.4

DEATH_PROBABILITY = 0.02
MUTATION_RATE = 1.0/50.0

N_OBSERVE_MIN = 1
N_OBSERVE_MAX = 6
OBS_MISTAKES_MIN = 0.0
OBS_MISTAKES_MAX = 0.5
OBS_DEVIATION_MIN =  1.0
OBS_DEVIATION_MAX = 10.0

PW_NOBSERVE = 1
PW_OBS_MISTAKES = 0.1
PW_OBS_DEVIATION = 3
PW_PC = 0.01


# MONITORING

LIVE_PLOT             = 0
REGISTER_FREQUENCIES  = 0
REGISTER_PAYOFFS      = 0
REGISTER_MEAN_PAYOFFS = 0
POST_MORTEM_ANALYSIS  = 0.0
POST_MORTEM_SEGMENT   = (0, MATCH_LENGTH) #(MATCH_LENGTH*3/4, MATCH_LENGTH)
POST_MORTEM_STRATEGIES= set([])

MONITOR_MATCHES = LIVE_PLOT + REGISTER_FREQUENCIES + REGISTER_PAYOFFS \
                  + REGISTER_MEAN_PAYOFFS
  

